SystemOrganization addCategory: 'GRID-Example-Model'!

Object subclass: #Course
	instanceVariableNames: 'subject dayOfTheWeek grades year attendance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Model'!

!Course methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 09:45'!
addStudent: aStudent withGrade: aGrade andAttendance: aPercentage
	self student: aStudent hasAttended: aPercentage.
	self grade: aGrade ofStudent: aStudent.
	aStudent addCourse: self.! !

!Course methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 01:54'!
amountOfPassingStudents 
	^self students count:[:student | student passedCourse:  self  ]! !

!Course methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 15:03'!
attendance
	^ attendance! !

!Course methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/24/2011 15:03'!
attendanceOfStudent: aStudent
	^self attendance at: aStudent ! !

!Course methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 14:46'!
code
	^ subject name, ' (', dayOfTheWeek , ')'! !

!Course methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/14/2011 20:57'!
codeAndSubject
	^ self subject name , ' - ', self code! !

!Course methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 14:47'!
dayOfTheWeek
	^ dayOfTheWeek! !

!Course methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 14:47'!
dayOfTheWeek: anObject
	dayOfTheWeek := anObject! !

!Course methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/24/2011 15:06'!
grade: aGrade ofStudent: aStudent
	self grades at: aStudent put: aGrade ! !

!Course methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2011 21:42'!
gradeForStudent:  aStudent
	^grades  at: aStudent ! !

!Course methodsFor: 'accessing' stamp: 'carlaGriggio 8/7/2011 21:44'!
grades
	^grades! !

!Course methodsFor: 'accessing' stamp: 'carlaGriggio 8/7/2011 21:44'!
grades: anObject
	grades := anObject! !

!Course methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/24/2011 15:03'!
initialize
	attendance := Dictionary new.
	grades:= Dictionary new.! !

!Course methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 12:09'!
percentageOfPassingStudents 
	^(self studentsCount > 0) ifTrue:[ self amountOfPassingStudents / self studentsCount * 100] ifFalse:[0]! !

!Course methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/20/2011 21:51'!
printOn: aStream
	aStream nextPutAll: self code! !

!Course methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/24/2011 15:03'!
student: aStudent hasAttended: aPercentage 
	self attendance at: aStudent put: aPercentage ! !

!Course methodsFor: 'accessing' stamp: 'carlaGriggio 8/25/2011 15:23'!
students
	^ grades keys! !

!Course methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 14:44'!
studentsCount
	^ grades size! !

!Course methodsFor: 'accessing' stamp: 'carlaGriggio 8/7/2011 21:44'!
subject
	^ subject! !

!Course methodsFor: 'accessing' stamp: 'carlaGriggio 8/7/2011 21:44'!
subject: anObject
	subject := anObject! !

!Course methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 14:47'!
year
	^ year! !

!Course methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 14:47'!
year: anObject
	year := anObject! !

Object subclass: #Student
	instanceVariableNames: 'id fullName courses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Model'!

!Student methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 09:45'!
addCourse: aCourse
	self courses add: aCourse ! !

!Student methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 09:43'!
anyFreeDay
	^(#(Monday Tuesday Wednesday Thursday Friday) reject:[:day | self courses anySatisfy: [:course | course dayOfTheWeek = day ] ]) anyOne! !

!Student methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 18:14'!
anyFreeDayOfYear: year
	^(#(Monday Tuesday Wednesday Thursday Friday) reject:[:day | (self courses reject:[:c | c year = year]) anySatisfy: [:course | (course dayOfTheWeek = day) ] ]) anyOne! !

!Student methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 10:37'!
attendanceOnCourse: aCourse
	^(aCourse attendanceOfStudent:  self ) * 100! !

!Student methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2011 21:48'!
averageGrade
	^courses average: [:course | self gradeOnCourse: course]! !

!Student methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 09:46'!
courses
	^courses ifNil:[courses := Set new] ! !

!Student methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 15:39'!
fullName
	^ fullName! !

!Student methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 15:39'!
fullName: anObject
	fullName := anObject! !

!Student methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2011 21:41'!
gradeOnCourse: aCourse
	^aCourse gradeForStudent: self ! !

!Student methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 15:24'!
passedCourse: aCourse 
	^(aCourse gradeForStudent:  self  ) > 4! !

!Student methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 10:35'!
passingMarkForCourse: aCourse
	^(self passedCourse:  aCourse ) ifTrue: ['Passed' ]ifFalse:['Failed']    ! !

Object subclass: #Subject
	instanceVariableNames: 'code name courses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Model'!

Subject class
	instanceVariableNames: 'universitySubjects'!

Subject class
	instanceVariableNames: 'universitySubjects'!

!Subject classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 01/30/2012 07:28'!
universitySubjects
|programmingParadigms  calculus1  algorithms  ui  s1  s2  s3  s4 paradigmsMonday students|
^universitySubjects ifNil:[


students := { (Student new fullName: 'Carla Griggio') . (Student new fullName: 'Guillermo Polito') . (Student new fullName: 'Santiago Bragagnolo') . (Student new fullName: 'Germn Leiva') . (Student new fullName: 'Dbora Fortini') . (Student new fullName: 'Nicols Passerini') . (Student new fullName: 'Mariana Matos') . (Student new fullName: 'Nicols Scarcella') . (Student new fullName: 'Guillermo Polito') . (Student new fullName: 'Alfredo Sanzo') . (Student new fullName: 'Federico Scarpa') . (Student new fullName: 'Adriel Paredes') . (Student new fullName: 'Gisela Decuzzi') } .



programmingParadigms := Subject new name: 'Programming Paradigms'; code: '082020'.
calculus1 := Subject new name: 'Calculus I'; code: '082020'.
ui := Subject new name: 'User Interfaces'; code: '082020'.
algorithms := Subject new name: 'Introduction to Algorithms'; code: '082020'.

s1 := Subject new name: 'Databases'; code: '083462'.
s2 := Subject new name: 'Calculus II'; code: '084612'.
s3 := Subject new name: 'Software Design'; code: '085634'.
s4 := Subject new name: 'Software Engineering'; code: '089633'.

{programmingParadigms . calculus1 . algorithms . ui . s1 . s2 . s3 . s4}  do:[:subject | subject courses: ( subject courses, (#(Monday Tuesday Wednesday Thursday Friday) collect: [:day |  Course new dayOfTheWeek: day; subject: subject; year:2010 ]))].

students  do: [:stud | 
	1 to: 5 do: [:num | 
	(Set with: ({programmingParadigms . calculus1 . algorithms . ui . s1 . s2 . s3 . s4} atRandom) ) do:[:subject | 
		(subject courseOnDay: (stud anyFreeDayOfYear: 2010)) addStudent:  stud withGrade: (2 to: 10) atRandom andAttendance: ((4 to: 10)  atRandom  / 10) ]]].

universitySubjects := {programmingParadigms . calculus1 . algorithms . ui . s1 . s2 . s3 . s4}.
]! !

!Subject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 17:35'!
averageQuantityOfStudentsInYear: aYear
	^(courses select:[:c | c year = aYear]) average: [:course |  course studentsCount ]! !

!Subject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2011 21:51'!
averageQuantityOfStudentsPerCourse
	^courses average: [:course |  course studentsCount ]! !

!Subject methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 14:49'!
code
	^ code! !

!Subject methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 14:49'!
code: anObject
	code := anObject! !

!Subject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 09:46'!
courseOnDay: aDay
	^courses detect:[:course | course dayOfTheWeek = aDay ]! !

!Subject methodsFor: 'accessing' stamp: 'carlaGriggio 8/25/2011 18:06'!
courses
	^ courses ifNil:[courses := OrderedCollection new]! !

!Subject methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 14:49'!
courses: anObject
	courses := anObject! !

!Subject methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 14:49'!
name
	^ name! !

!Subject methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2011 14:49'!
name: anObject
	name := anObject! !

!Subject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/20/2011 21:50'!
printOn: aStream
	aStream nextPutAll: self name! !

!Subject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2011 22:11'!
studentsCount
	^courses sum: [:course |  course studentsCount ]! !

!Subject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 17:37'!
studentsCountInYear: aYear
	^(courses select:[:c | c year = aYear ]) sum: [:course |  course studentsCount ]! !

!Collection methodsFor: '*GRID-Example-Model' stamp: 'carlaGriggio 8/7/2011 21:48'!
average: aBlock
	^( self sum: aBlock) / self size! !
